#!/bin/env python

import sys
import urllib

UTILS = 'http://www.ncbi.nlm.nih.gov/entrez/eutils'
DB = 'Pubmed'

def search(query, field='', retmax=100):
    pmids = []
    
    url = '%s/esearch.fcgi?db=%s&retmax=%d&term=%s' % (
        UTILS, DB, retmax, urllib.quote(query)
        )
    if field:
        url += '&field=%s' % field
    f = urllib.urlopen(url)
    for line in f:
        line = line.strip()
        if line.startswith('<Id>'):
            pmid = int(line[4:-5])
            pmids.append(pmid)
    return pmids

def fetch(pmid):
    url = '%s/efetch.fcgi?db=%s&rettype=full&retmode=xml&id=%s' % (
        UTILS, DB, str(pmid)
        )
    f = urllib.urlopen(url)
    return f

if __name__ == '__main__':
    pmids = search(sys.argv[1])
    f = fetch(','.join([str(pmid) for pmid in pmids]))
    sys.stdout.write(f.read())
